image: tukangremot/php7.4:latest

stages:
  - build
  - test

test-env:
  stage: build
  cache:
    key: ${CI_COMMIT_REF_SLUG}-test-env
    paths:
      - vendor/
  script:
      - composer install
      - cp .env.example .env
  artifacts:
    expire_in: 1 month
    paths:
      - vendor/
      - .env
  only:
    - branches
  except:
    - tags

phpunit:
  stage: test
  services:
    - mongo:latest
  dependencies:
    - test-env
  script:
    - vendor/bin/phpunit --configuration phpunit.xml --coverage-text --colors=never --stderr
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'
  only:
    - branches
  except:
    - tags

phpcs:
  stage: test
  dependencies:
    - test-env
  script:
    - vendor/bin/phpcs
  only:
    - branches
  except:
    - tags